1000 : REMark -----------------------------------------------------
1010 : REMark examples for inflate and deflate programs
1020 : REMark requires named pipe driver for asynchronous examples
1030 : REMark The Freeware NPIPE driver (Hans Lub) is fine.
1040 : REMark Free and freely distributable (c) 1997 Jonathan Hudson
1050 : REMark -----------------------------------------------------
1060 :
1070 : REMark Deflate file to file
1080 :
1090 DEFine PROCedure df2f(in$,out$)
1100  PRINT "Deflate file to file"
1110  EW deflate;' '&in$&' '&out$
1120 END DEFine
1130 :
1140 : REMark Inflate file to file
1150 :
1160 DEFine PROCedure if2f(in$,out$)
1170  PRINT "Inflate file to file"
1180  EW inflate;' '&in$&' '&out$
1190 END DEFine
1200 :
1210 : REMark Inflate memory to memory (and save as file)
1220 : REMark Slightly tricky, as we have to guess how big the
1230 : REMark resultant output may be
1240 : REMark also shows how to see how big the result was
1250 :
1260 DEFine PROCedure im2m (in$,out$)
1270  LOCal a,b,c,a$,c$,x$,ch
1280  PRINT "Inflate memory to memory"
1290  a = ALCHP(300000)
1300  a$ =HEX$(a,32)
1310  b = FLEN(\in$)
1320  c = ALCHP(b)
1330  LBYTES in$,c
1340  c$ = HEX$(c,32)
1350  x$ = ' 0x'&c$&' '&b&' 0x'&a$&' 300000'
1360  EX inflate,pipe_inflate_64;x$
1370  ch = FOP_IN('pipe_inflate')
1380  INPUT #ch,a$
1390  CLOSE #ch
1400  PRINT 'Inflated to ';a$;' bytes'
1410  SBYTES_O out$,a,a$
1420  RECHP(a)
1430  RECHP(c)
1440 END DEFine
1450 :
1460 : REMark Deflate memory to memory (and save as file)
1470 : REMark Slightly less tricky, we still have to guess how big the
1480 : REMark resultant output may be; use input size as guess
1490 : REMark also shows how to see how big the result was
1500 :
1510 DEFine PROCedure dm2m(in$,out$)
1520  LOCal a,b,b1,c,a$,c$,x$,ch
1530  PRINT "Deflate memory to memory"
1540  b = FLEN(\in$)
1550  b1 = b*1.001 + 16
1560  c = ALCHP(b)
1570  LBYTES in$,c
1580  c$ = HEX$(c,32)
1590  a = ALCHP(b1)
1600  a$ =HEX$(a,32)
1610  x$ = ' 0x'&c$&' '&b&' 0x'&a$&' '&b1
1620  EX deflate,pipe_deflate_64;x$
1630  ch = FOP_IN('pipe_deflate')
1640  INPUT #ch,a$
1650  CLOSE #ch
1660  PRINT 'deflated to ';a$;' bytes'
1670  SBYTES_O out$,a,a$
1680  RECHP(a)
1690  RECHP(c)
1700 END DEFine
1710 :
1720 DEFine PROCedure df2m(in$,out$)
1730  LOCal a,b,b1,a$,x$,ch
1740  PRINT "Deflate file to memory"
1750  b = FLEN(\in$)
1760  b1 = b*1.001 + 16
1770  a = ALCHP(b1)
1780  a$ =HEX$(a,32)
1790  x$ = CHR$(0)&in$&CHR$(0)&'0x'&a$&CHR$(0)&b1
1800  EX deflate,pipe_deflate_64;x$
1810  ch = FOP_IN('pipe_deflate')
1820  INPUT #ch,a$
1830  CLOSE #ch
1840  PRINT 'deflated to ';a$;' bytes'
1850  SBYTES_O out$,a,a$
1860  RECHP(a)
1870  END DEFine
1880 :
1890 DEFine PROCedure dm2f(in$,out$)
1900  LOCal b,c,c$,x$,ch
1910  PRINT "Deflate memory to file"
1920  b = FLEN(\in$)
1930  c = ALCHP(b)
1940  LBYTES in$,c
1950  c$ = HEX$(c,32)
1960  x$ = ' 0x'&c$&' '&b&' '&out$
1970  EX deflate,pipe_deflate_64;x$
1980  ch = FOP_IN('pipe_deflate')
1990  INPUT #ch,a$
2000  CLOSE #ch
2010  PRINT 'deflated to ';a$;' bytes'
2020  RECHP(c)
2030 END DEFine
2040 :
2050 DEFine PROCedure if2m(in$,out$)
2060  LOCal a,a$,x$,ch
2070  PRINT "Inflate file to memory"
2080  a = ALCHP(300000)
2090  a$ =HEX$(a,32)
2100  x$ = ' '&in$&' 0x'&a$&' 300000'
2110  EX inflate,pipe_inflate_64;x$
2120  ch = FOP_IN('pipe_inflate')
2130  INPUT #ch,a$
2140  CLOSE #ch
2150  PRINT 'Inflated to ';a$;' bytes'
2160  SBYTES_O out$,a,a$
2170  RECHP(a)
2180 END DEFine
2190 :
2200 DEFine PROCedure im2f(in$,out$)
2210  LOCal b,c,c$,x$,a$,ch
2220  PRINT "Inflate memory to file"
2230  b = FLEN(\in$)
2240  c = ALCHP(b)
2250  LBYTES in$,c
2260  c$ = HEX$(c,32)
2270  x$ = ' 0x'&c$&' '&b&' '&out$
2280  EX inflate,pipe_inflate_64;x$
2290  ch = FOP_IN('pipe_inflate')
2300  INPUT #ch,a$
2310  CLOSE #ch
2320  PRINT 'Inflated to ';a$;' bytes'
2330  RECHP(c)
2340 END DEFine
2350 :
2360 DEFine PROCedure TestAll (fnm$)
2370  LOCal ch1,ch2,a1$,a2$,plugh,n,er%,offset%,stem$
2380  offset% = '.' INSTR fnm$
2390  stem$ = fnm$(TO offset%)
2400  df2f fnm$,stem$&'dff'
2410  if2f stem$&'dff',stem$&'iff'
2420  df2m stem$&'iff',stem$&'dfm'
2430  if2m stem$&'dfm',stem$&'ifm'
2440  dm2f stem$&'ifm',stem$&'dmf'
2450  im2f stem$&'dmf',stem$&'imf'
2460  dm2m stem$&'imf',stem$&'dmm'
2470  im2m stem$&'dmm',stem$&'imm'
2480  PRINT "Checking file consistency ...."
2490  ch1 = FOP_IN(fnm$)
2500  ch2 = FOP_IN(stem$&'imm')
2510  n = 0
2520  er% = 0
2530  REPeat plugh
2540   IF EOF(#ch1) AND  EOF(#ch2) : EXIT plugh
2550   INPUT #ch1,a1$
2560   INPUT #ch2,a2$
2570   n = n + 1
2580   IF a1$ <> a2$ THEN
2590    er% = 1
2600    EXIT plugh
2610   END IF
2620  END REPeat plugh
2630  IF er% THEN
2640   PRINT "Files differ at line ";n
2650  ELSE
2660   PRINT "Files are identical"
2670  END IF
2680 END DEFine
2690 : REMark change separator above if necessary
2700 TestAll ('win2_tmp_perl.faq')
